// Button Colors
@mixin solid-btn($color, $textcolor, $bordercolor: $color, $hovertextcolor: $color) {
  &:not([disabled]),
  &:not(.disabled) {
    color: textColorAccordingToBackground($color, $textcolor);
    // color: $textcolor;
    background-color: $color;
    // @if $bordercolor {
      border-color: $bordercolor;
    // } @else {
    //   border-color: $color;
    // }
    &:not(.no-hover){
      &:hover,
      &:focus,
      &.focus,
      &:active,
      &.active {
        background: transparent;
        text-decoration: none;
        color: textColorAccordingToBackground($color, $hovertextcolor);
        // color: $color;
        outline: 0;
        // -webkit-box-shadow: 0 0 5px rgba(0, 123, 255, 0.25);
        // box-shadow: 0 0 5px rgba(0, 123, 255, 0.25);
      }
    }
    &.no-shadow {
      &:hover,
      &:focus,
      &.focus,
      &:active,
      &.active {
        -webkit-box-shadow: none;
        box-shadow: none;
      }
    }
  }
  &[disabled],
  &.disabled{
    color: textColorAccordingToBackground($color, $textcolor);
    background-color: $color;
    border-color: $color;
    cursor: not-allowed;
  }
}

@mixin outline-btn($color, $textcolor: $color, $bordercolor: $color, $hoverbackgroundcolor: $color, $hovertextcolor: $white) {
  &:not([disabled]),
  &:not(.disabled) {
    // @if $textcolor {
      color: $textcolor;
      // color: textColorAccordingToBackground($color, $textcolor);
    // } @else {
      // color: $color;
    // }
    background-color: transparent;
    // @if $bordercolor {
      border-color: $bordercolor;
    // } @else {
    //   border-color: $color;
    // }
    &:not(.no-hover){
      &:hover,
      &:focus,
      &.focus,
      &.active {
        // @if $hoverbackgroundcolor{
        //   background: $hoverbackgroundcolor;
        //   border-color: $hoverbackgroundcolor;
        // } @else {
        //   background: $color;
        //   border-color: $color;
        // }
        background: $hoverbackgroundcolor;
        border-color: $hoverbackgroundcolor;
        text-decoration: none;
        // @if $hovertextcolor{
        //   color: $hovertextcolor;
        // } @else {
        //   color: $hovertextcolor;
        // }
        color: textColorAccordingToBackground($color, $hovertextcolor);
        outline: 0;
        // -webkit-box-shadow: 0 0 5px rgba(0, 123, 255, 0.25);
        // box-shadow: 0 0 5px rgba(0, 123, 255, 0.25);
      }
      &.no-shadow {
        &:hover,
        &:focus,
        &.focus,
        &:active,
        &.active {
          -webkit-box-shadow: none;
          box-shadow: none;
        }
      }
    }
  }
  &[disabled],
  &.disabled{
    color: textColorAccordingToBackground($color, $textcolor);
    background-color: transparent;
    @if $bordercolor {
      border-color: $bordercolor;
    } @else {
      border-color: $color;
    }
    cursor: not-allowed;
  }
}
@mixin gradient($direction, $list) { 
  background-image: -webkit-linear-gradient($direction, $list);
  background-image: -moz-linear-gradient($direction, $list);
  background-image: -o-linear-gradient($direction, $list);
  background-image: linear-gradient($direction, $list);
  @if length($list) > 2 {
    background-size: 300% 100%;
  } @else {
    background-size: contain;
  }
  color: textColorAccordingToBackground(nth($list, 1), $white);
  border: none;
  transition: all ease 0.3s;
  &:not(.no-hover){
    &:hover,
    &:focus,
    &.focus,
    &:active,
    &.active {
      background-position: 100% 0;
      // text-decoration: none;
      color: textColorAccordingToBackground($green, $white);
      // color: $color;
      outline: 0;
      // -webkit-box-shadow: 0 0 5px rgba(0, 123, 255, 0.25);
      // box-shadow: 0 0 5px rgba(0, 123, 255, 0.25);
    }
  }
  &.no-shadow {
    &:hover,
    &:focus,
    &.focus,
    &:active,
    &.active {
      -webkit-box-shadow: none;
      box-shadow: none;
    }
  }
}
// Calc
@mixin calc($property, $expression) {
  #{$property}: -moz-calc(#{$expression});
  #{$property}: -webkit-calc(#{$expression});
  #{$property}: calc(#{$expression});
}
// Badges
@mixin solid-badge($color, $textcolor) {
    color: $textcolor;
    background-color: $color;
    border-color: $color;
    &[href]{
      &:hover,
      &:focus,
      &.focus,
      &.active {
        background: transparent;
        text-decoration: none;
        color: $color;
        outline: 0;
        -webkit-box-shadow: 0 0 5px rgba(0, 123, 255, 0.25);
        box-shadow: 0 0 5px rgba(0, 123, 255, 0.25);
      }
    }
}
// Custom Popups Effect
// No effect
@mixin no-effect-hidden() {
  visibility: hidden;
  opacity: 0;
  transform: translate(0);
}
@mixin no-effect-shown() {
  visibility: visible;
  opacity: 1;
  overflow-y: auto;
  transform: translate(0);
}
// Zoom in out effect
@mixin zoom-out() {
  width: calc(100% - 100px);
  height: calc(100% - 100px);
  transform: translateX(0%) translateY(50px);
}
@mixin zoom-in() {
  width: 100%;
  height: 100%;
  overflow-y: auto;
  transform: translateX(0%) translateY(0%);
}
// Slide in out effect
@mixin slide-out($direction) {
  @if $direction == 'left' {
    left: 0;
    transform: translateX(-100%) translateY(0);
  } @else {
    right: 0;
    transform: translateX(100%) translateY(0);
  }
}
@mixin slide-in($direction) {
  @if $direction == 'left' {
    overflow-y: auto;
    transform: translateX(0) translateY(0);
  } @else {
    overflow-y: auto;
    transform: translateX(0) translateY(0);
  }
}
@mixin hr-text($hrcolor: $sdarkgreylight) {
  position: relative;
  z-index: 0;
  display: flex;
  white-space: nowrap;
  align-items: center;
  &::before,
  &::after {
    content: '';
    width: 50%;
    height: 1px;
    background: $hrcolor;
    display: inline-block;
  }
  &::before {
    margin-right: rem(15);
  }
  &::after {
    margin-left: rem(15);
  }
}
